#!/bin/bash

# run the following:
# CERW_batch_setup.m: matlab script to generate preprocessed and seed images for input to segmentation algorithm
# CERW_3D: run the segmentation
# CERW_batch_postprocess.m: matlab script to output tif files from the segmentation files

# requirements: MATLAB 2018a, cuda 10.1

matlab_exec="/usr/local/MATLAB/R2018b/bin/matlab"
seg_exec="./CERW_3D"

dataset_name="Fluo-C3DH-A549-SIM"
series_name="01"
beta="4000"
kappa="0.3"

inter_dir="./"$dataset_name"/"
mkdir $inter_dir

data_dir="../"$dataset_name"/"
input_dir=$data_dir$series_name"/"
pre_dir=$inter_dir$series_name"_pre/"
seed_dir=$inter_dir$series_name"_seed/"
seg_dir=$inter_dir$series_name"_seg/"
out_dir=$data_dir$series_name"_RES/"

matlab_options_path="./"$dataset_name"-"$series_name".mat"
seg_params_path="./"$dataset_name"-"$series_name".txt"

$matlab_exec -nodesktop -nosplash -r "CERW_batch_setup('"$input_dir"','"$pre_dir"','"$seed_dir"','"$matlab_options_path"');exit"

$seg_exec "-i" $pre_dir "-s" $seed_dir "-o" $seg_dir "-b" $beta "-k" $kappa "-p" "batch"

$matlab_exec -nodesktop -nosplash -r "CERW_batch_postprocess('"$seg_dir"','"$out_dir"','"$matlab_options_path"');exit"
